
<div class="row">
 <div class="col-12 d-flex justify-content-between" >
   <a href="/teaching/xml/xmlschema"class="btn btn-primary" role="button" >Xml Schema </a> <a href="/teaching/"class="btn btn-primary" role="button" >Sommaire </a>  <a href="/teaching/xml/xslt"class="btn btn-primary" role="button" >XSLT</a>
 </div></div>
<h1><%= title %> </h1>
<hr/>


<h2>Définition</h2>
<hr/>

<h3>XML Path Language (XPath) :</h3>
   <ul> 
        <li>Expressions pour naviguer et sélectionner de l'information dans un document XML.</li>
        <li>Standard recommandé par W3C.</li>
    </ul>
 
       <div class="alert alert-info" role="alert" >XPath s'intègre à beaucoup d'autres langages : XSLT, XQuery, C++, Java, Python, JavaScript...</div>

<h3>Exemple</h3>
<pre><code>&lt;notes&gt;
  &lt;note color="yellow"&gt;
    &lt;from&gt;Bob&lt;/from&gt;
    &lt;message&gt;Pense à sortir le chat...&lt;/message&gt;
  &lt;/note&gt;
  &lt;note color="pink"&gt;
    &lt;from&gt;Alice&lt;/from&gt;
    &lt;message&gt;Fais le toi-même !&lt;/message&gt;
  &lt;/note&gt;
</code></pre>

<p>L'expression pour selectionner tous les messages :</p> 
<pre><code>/notes/note/message</code></pre>

<p>Résultats :</p>

<pre><code>&lt;message&gt;Pense à sortir le chat...&lt;/message&gt;
&lt;message&gt;Fais le toi-même !&lt;/message&gt;
</code></pre>

<h2>Structure</h2>
<hr/>
Les documents XML ont une représentation arborescente.
<img src="/images/courses/XML/xml_schema"width="540px" />

<h2>Vocabulaire</h2>
<hr/>
<ul>
    <li>Noeud : composant du document (texte, élement, attribut, commentaire...).</li>
    <li>Parent : élément qui a des enfants.</li>
    <li>Enfant<i>(child)</i> : élément qui a un parent. </li>
    <li>Voisin<i>(sibling)</i> : élément sur un même niveau.</li>
    <li>ancêtre :ensemble des parents d'un élémént.</li>
    <li>Descendant : ensemble des enfants d'un élément.</li>
</ul>


<h2>Navigation</h2>
<hr/>
<p>Xpath utilise des expressions pour naviguer dans un document XML, à la manière
d'un système de fichier.</p>

<pre><code>
/root
/root/child
/root/child/subchild
...
</code></pre>

<h2>Syntaxe</h2>
<hr/>
<h3>Selection</h3>

<table class="table">
    <tr>
        <td>"nodename"</td>
        <td>Noeud.</td>
    </tr>
    <tr>
        <td>/</td>
        <td>Depuis la racine.</td>
    </tr>
    <tr>
        <td>//</td>
        <td>Depuis n'importe ou</td>
    </tr>
    <tr>
        <td>..</td>
        <td>Parent du noeud courant</td>
    </tr>
    <tr>
        <td>@</td>
        <td>Attributs</td>
    </tr>
</table>

<p>Exemples : </p>
<pre><code>/notes/note/from
//from
</code></pre>

<p>Resultats : </p>
<pre><code>&lt;from&gt;Bob&lt;/from&gt;
&lt;from&gt;Alice&lt;/from&gt;
</code></pre>

<h3>Prédicats</h3>
<p>Sélection d'un noeud spécifique (entre crochets []). Par exemple : </p>

<table class="table">
    <tr>
        <td>notes/note[1]/message</td>
        <td>Message de la première note.</td>
    </tr>
    <tr>
        <td>//note[@color='pink']</td>
        <td>Les notes dont l'attibut <b>color</b> sont pink </td>
    </tr>
    <tr>
        <td>//note[from='Bob']/message</td>
        <td>Tous les messages de Bob</td>
    </tr>
</table>


<h3>Opérateurs</h3>
<p>Opérateurs de comparaison :</p>

<table class="table">
    <tr>
        <td>=, != </td>
        <td>Egal, différent.</td>
    </tr>
    <tr>
        <td>&lt;, &lt;=, &gt;, &gt;=, </td>
        <td>Inégalités</td>
    </tr>
    <tr>
        <td>or</td>
        <td>Ou logique</td>
    </tr>
    <tr>
        <td>and</td>
        <td>ET logique</td>
    </tr>
</table>



<h3>Mathématique</h3>
<p>Opérateurs mathématiques:</p>

<table class="table">
    <tr>
        <td>+</td>
        <td>Addition.</td>
    </tr>
    <tr>
        <td>-</td>
        <td>Soustraction</td>
    </tr>
    <tr>
        <td>*</td>
        <td>Multiplication</td>
    </tr>
     <tr>
        <td>div</td>
        <td>Division</td>
    </tr>
</table>

<h3>Fonctions</h3>
<p>XPath propose une multitude de fonctions intégré :</p>

<table class="table">
    <tr>
        <td>sum(expr)</td>
        <td>Somme des éléments récupérés par l'expression <b>expr</b>.</td>
    </tr>
    <tr>
        <td>Count(expr)</td>
        <td>Comptage des éléments récupérés par l'expression.</td>
    </tr>
    <tr>
        <td>last()</td>
        <td>Dernier éléments (à utiliser dans un prédicat). </td>
    </tr>
     <tr>
        <td>...</td>
        <td><a href="http://www.edankert.com/xpathfunctions.html">liste complète </a></td>
    </tr>
</table>

<h2>Documentation</h2>
<hr/>
<a href="https://www.w3schools.com/xml/xpath_intro.asp">Lien</a>
<br/>
<br/>
<br/>
<div class="row">
 <div class="col-12 d-flex justify-content-between" >
   <a href="/teaching/xml/xmlschema"class="btn btn-primary" role="button" >Xml Schema </a> <a href="/teaching/"class="btn btn-primary" role="button" >Sommaire </a>  <a href="/teaching/xml/xslt"class="btn btn-primary" role="button" >XSLT</a>
 </div>
</div>
